<?php
/*
v0.70
*/
//error_reporting(E_ALL);

define("VOLLE_URL", $core->url);
define("THEMA", $core->template);
define("HR_KLEUR", $core->hr_kleur);
define("TABEL_ALT_BG", $core->tabel_alt_bg);

$parse_array = array(
//         Begintag, eindtag, begin, parameter func, eindafsluiter, functie tekst, eindvervanger, tussentags, toegestane tags, tag level
'img' =>     array('img',    0, '',    1,    ' ',    0,    '',    0,    0),
//'email' =>   array('email',0, '<a',    3,    '</a>',0,'',1,0),
'url' =>     array('url',     1, '<a',    2,    '>',     3,    '</a>',    1,    0),
'quote' =>     array('quote',1, '<blockquote><font size=1>Quote:</font><table width="90%" cellpadding="4" cellspacing="0" border="0" bgcolor="'.TABEL_ALT_BG.'" style="border: '.HR_KLEUR.' 1px solid"><tr><td width="100%">',0,'',    0,'</td></tr></table></blockquote>',0,    0),
'code' =>     array('code',1, '<blockquote><font size=1>Code: </font><table width="90%" cellpadding="3" cellspacing="0" border="0" style="border: '.HR_KLEUR.' 1px solid" bgcolor="'.TABEL_ALT_BG.'"><tr><td width="100%">',0,'',1,'</td></tr></table></blockquote>',2, 0),
'sub' =>    array('sub', 1, '<sub>',    0,      '',     0,    '</sub>',0,    1),
'sup' =>    array('sup', 1, '<sup>',    0,      '',     0,    '</sup>',0,    1),
'br' =>     array('br',     0, '<br />',    0,    '',     0,    '',    0,    1),
'b' =>         array('b',    1, '<b>',    0,    '',     0,    '</b>',    0,    1),
'u' =>         array('u',    1, '<u>',    0,    '',     0,    '</u>',    0,    1),
'i' =>         array('i',    1, '<i>',    0,    '',     0,     '</i>',    0,    1),
's' =>         array('s',    1, '<s>',    0,    '',     0,    '</s>',    0,    1),
);

$start_of_tag = "[";
$end_of_tag = "]";
$end_tag_char = "/";

$default_function = "html_text";

//Preparser voor luie mensen
$pre_parse_find = array(
'!\[url\](http://|https://|mailto:|www.)??(.*)\[\/url\]!Ui', //Vervangen door een default parameterd url
'!\[img\](.+)\[/img\]!Usi',
//'!\[email\](.+)\[/email\]!Usi',
//'!(^|[ \n\r\t])(((ftp://)|(http://))(([a-z0-9_-]+)(:([a-z0-9_-]+([a-z0-9_-]+\@)?))?\@)?(www\.)?([a-z0-9_-]|\.)+(\.[a-z]{2,3})(\:[0-9]+)?(/[^/: \n\r]*)*)!i', // Jaapf's regexp voor url's
//'!(^|[ \n\r\t])([a-z_-][a-z0-9\._-]*@[a-z0-9_-]+(\.[a-z0-9_-]+)+)!i', // Jaapf's regexp voor email
'!(^|[ \n\r\t])(((ftp://)|(http://)|(https://))(([a-z0-9_-]+)(:([a-z0-9_\-]+([a-z0-9_\-]+\@)?))?\@)?(www\.)?([a-z0-9_-]|\.)+(\.[a-z]{2,4})(\:[0-9]+)?(/[^/: \n\r]*)*)!i', // Jaapf's regexp voor url's
//'!(^|[ \n\r\t])([a-z_-][a-z0-9\._-]*@[a-z0-9_-]+(\.[a-z0-9_-]+)+)!i', // Jaapf's regexp voor email
);

$pre_parse_replace = array(
'[url=\1\2]\2[/url]', //moet dan dus ook weg '$parse_array['url'][2] . build_param('$parse_array['url'][2], 'url', 'url=\1\2') . $parse_array['url']
'[img=\1]',
//'[email=\1]',
//'\1[url=\2]\2[/url]',
//'\1[email=\2]',
'\1[url=\2]\2[/url]',
//'\1[email=\2]',
);

$in_parse = array(
//'!(^|[ \n\r\t])(((ftp://)|(http://))(([a-z0-9_-]+)(:([a-z0-9_\-]+([a-z0-9_\-]+\@)?))?\@)?(www\.)?([a-z0-9_-]|\.)+(\.[a-z]{2,4})(\:[0-9]+)?(/[^/: \n\r]*)*)!i', // Jaapf's regexp voor url's
//'!(^|[ \n\r\t])([a-z_-][a-z0-9\._-]*@[a-z0-9_-]+(\.[a-z0-9_-]+)+)!i', // Jaapf's regexp voor email
);

$in_replace = array(
//'\1[url=\2]\2[/url]',
//'\1[email=\2]\2[/email]',
);

$smilie_find = array(
':)', 
':-)', 
':-(', 
':(', 
':S', 
':s', 
':-S', 
':-s', 
':D', 
':d', 
':-D', 
':-d', 
':O', 
':o', 
':-O', 
':-o', 
':|', 
':-|', 
':-P', 
':-p', 
':P', 
':p', 
'(6)', 
':@', 
':-@', 
':$', 
':-$', 
';-)',
';)',
':\'(',
':-\'(',
'(*)',
'(!)',
'(%)',
'(#)',
':A',
':-A',
':}',
':X',
':-X',
':L',
':-L',
'(sint)',
'(piet)',
'(champagne)',
'(kerstman)',
'(engel)',
'(feest)',
'(afgestudeerd)',
'(n)',
'(y)',
'(koffie)',
);

$smilie_replace = array(
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_blij.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_blij.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_nietblij.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_nietblij.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verward.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verward.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verward.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verward.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_ergblij.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_ergblij.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_ergblij.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_ergblij.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verrast.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verrast.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verrast.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verrast.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_neutraal.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_neutraal.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_grappig.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_grappig.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_grappig.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_grappig.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_duivels.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_boos.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_boos.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verlegen.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_verlegen.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_knipoog.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_knipoog.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_huilen.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_huilen.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_zon.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_uitroep.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_idee.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_schamen.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_erg_boos.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_erg_boos.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_pijl.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_geschokt.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_geschokt.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_lachen.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_lachen.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_sint.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_piet.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_nieuwjaar.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_kerstman.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_engel.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_feest.gif" border="0">', 
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_afgestudeerd.gif" border="0">',
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_duimomlaag.gif" border="0">',
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_duim.gif" border="0">',
'<img src="'.VOLLE_URL.'thema/'.THEMA.'/smilies/smilie_koffie.gif" border="0">',
);

function build_param($function, $input, $param="")
{
    switch ($function)
    {
        case 0 : return;
        case 1 : {return build_img($input, $param);} // Images
        case 2 : {return build_url($input, $param);} // Urls
        case 3 : {return build_email($input, $param);} // Emails
        case 4 : {return build_list($input, $param);} // Lists
        case 5 : {return build_list_item($input, $param);} // List items
        default : return;
    }
}

function build_html($function, $input, $param="", $smilies=true, $admin=false, $inparse=true)
{
    switch ($function)
    {
        case 0 : {return html_text($input, $param, $smilies, $admin, true, $inparse);}//Standaard functie bij html
        case 1 : {return highlight_php($input, $param);} // PHP
        case 2 : {return html_text($input, $param, $smilies, $admin, false, $inparse);} //Maar dan zonder nl2br :)
        case 3 : {return html_text($input, $param, false, false, false, false);} // code
        case 4 : {return html_text($input, $param, true, false, false, false);} // url
        default :{return html_text($input, $param, $smilies, $admin, true, $inparse);}//Standaard functie bij html
    }
}

// Maakt een html-leesbare string van de tekst
function html_text($input, $param="", $smilies=true, $admin=false, $nl2br=true, $inparse=true)
{
    global $smilie_find, $smilie_replace, $in_parse, $in_replace;
    $output = $input;
    if(!$admin)
        $output = htmlentities($output);
    if($nl2br)
        $output = nl2br($output);
    if($smilies)
        $output = str_replace($smilie_find, $smilie_replace, $output);
    if($inparse)
        $output = preg_replace($in_parse, $in_replace, $output);
    return $output;
}

function build_url($input, $param)
{
    $use_string = preg_replace("!javascript:!i", "JAVASCRIPT IS NOT ALLOWED", $param);
    if($param)
    {
        //Nu hebben we dus een parameter setje...
        $matchem = array('!url=([a-zA-Z0-9%\./\:\-_~\?=\+&]+)!i');
        foreach($matchem as $match)
            {
                preg_match($match, $use_string, $matches[]);
            }

            return " href='{$matches[0][1]}' target='_blank'";
    }
    elseif(preg_match('!url=(.*)!i', $param))
    {
        return preg_replace('!url=(.*)!i', ' href="\1" target="_blank"', $param);
    }
    else
        return false;
}

function build_img($input, $param)
{
    $use_string = preg_replace("!javascript:!i", "JAVASCRIPT IS NOT ALLOWED", $param);
    if($param)
    {
        //Nu hebben we dus een parameter setje...
        $matchem = array('!img=([a-zA-Z0-9%\./\:\-_~\?=\+]+)!i', '![hH]=([0-9]+)!', '![wW]=([0-9]+)!');
        foreach($matchem as $match)
        {
            preg_match($match, $use_string, $matches[]);
        }
		
		$size = GetImageSize($matches[0][1]);
		$size[2] = $size[0];
		
		$real[0] = $size[0];
		$real[1] = $size[1];

		if($size[0] > 400) {    
			$size[0] = 400;  

		   	## De nieuwe hoogte berekenen 
			$size[2] = $size[2] / $size[0];    
			$size[1] = $size[1] / $size[2];    
		}
		elseif($size[1] > 400) {
			$size[1] = 400;  

		   	## De nieuwe hoogte berekenen 
			$size[2] = $size[2] / $size[1];    
			$size[1] = $size[0] / $size[2];    			
		}

		$matches[1][1] = $size[1];
		$matches[2][1] = $size[0];

        if(isset($matches[1][1])) {
            $height=" height='{$matches[1][1]}'";
		}
        if(isset($matches[2][1])) {
            $width=" width='{$matches[2][1]}'";
		}

        return "<a href=\"javascript:void(0)\" onClick=\"window.open('".$matches[0][1]."', 'popup', 'height=".($real[1]+20).",width=".($real[0]+20).",fullscreen=no,location=no,menubar=no,status=no,toolbar=no,scrollbars=no,resizable=no')\"><img src='{$matches[0][1]}'$height$width alt=\"Klik op dit plaatje voor de ware grootte!\" border='0'></a>";
    }
    else {
        $return = preg_replace('!img=(.+)(?=(\s|$))!i', ' src="\1" alt="Dit plaatje is mogelijk verkleind!">', $input);
		return  "<a href=\"javascript:void(0)\" onClick=\"window.open('".$matches[0][1]."', 'popup', 'height=".($real[1]+20).",width=".($real[0]+20).",fullscreen=no,location=no,menubar=no,status=no,toolbar=no,scrollbars=no,resizable=no')\"><img ".$return." border='0'></a>";
	}
		
}

function build_email($input, $param)
{
    $use_string = preg_replace("!javascript:!i", "JAVASCRIPT IS NOT ALLOWED", $param);
    if($param)
    {
        //Nu hebben we dus een parameter setje...
        $matchem = array('!email=([a-zA-Z0-9%\./\:\-_~\?=\+@]+)!i');
        foreach($matchem as $match)
        {
            preg_match($match, $use_string, $matches[]);
        }

        return " href=\"mailto:{$matches[0][1]}\">{$matches[0][1]}";
    }
    return preg_replace('!email=(.+)(?=(\s|$))!i', ' href="mailto:\1">\1', $input);
}

function build_list($input, $param)
{
    if($param)
    {
        $use_string = preg_replace("!javascript!i", "JAVASCRIPT IS NOT ALLOWED", $param);
        $matchem = array('!list=([Aa1iI])!i', '!s=([0-9]+)!i');
        foreach($matchem as $match)
        {
            preg_match($match, $use_string, $matches[]);
        }
        if(!isset($matches[0][1]))
        {
            $matches[0][1] = '';
        }
        if(!isset($matches[1][1]))
        {
            $matches[1][1] = '';
        }
        return " type='{$matches[0][1]}' start='{$matches[1][1]}' ";
        //Nu hebben we dus een parameter setje...
    }
    else
        return preg_replace('!list=([Aa1iI])(?=(\s|$))!i', ' type="\1"', $input);
}

function build_list_item($input, $param)
{
    if($param)
    {
        $use_string = preg_replace("!javascript!i", "JAVASCRIPT IS NOT ALLOWED", $param);
        $match = '!li=([0-9]+)!i';
        if(preg_match($match, $use_string, $matches))
            return " value='$matches[1]' ";
        //Nu hebben we dus een parameter setje...
    }
}

/*function highlight_php($input, $param)
{

    $input = trim($input);
    
	ob_start();
    
	@highlight_string($input);
    $output = ob_get_contents();

    ob_end_clean();
    
	$exp = explode("<br />", $output);
	$aantal = count($exp);

	$i_comb = '';

	for($i = 0; $i < $aantal; $i++) {
		$iplus = $i+1;
		$i_comb .= '<center>'.$iplus."<br></center>\n";
	}

	$output = '<table width="100%" cellpadding="3" cellspacing="0" border="0"><tr><td width="20" align="center" bgcolor="'.TABEL_ALT_BG.'">'.$i_comb.'</td><td width="100%" nowrap>'.$output.'</td></tr></table>';

	return $output;
}*/

function highlight_php($input, $param)
{

    $input = trim($input);
    ob_start();
    @highlight_string($input);
    $output = ob_get_contents();
    ob_end_clean();
    return $output;
}

/*function highlight_php($input, $param)
{

    $input = trim($input);
    
	ob_start();
    
	@highlight_string($input);
    $output = ob_get_contents();

    ob_end_clean();
    
	$output = explode("<br />", $output);

	for($i = 1; $i <= count($output); $i++) {
		$output[$i-1] = '<tr><td width="15" bgcolor="'.TABEL_ALT_BG.'"><img src="'.VOLLE_URL.'include/nummer.php?nummer='.$i.'"></center></td><td><code>'.$output[$i-1].'</code></td></tr>';
	}

	$output = '<table width="100%" cellpadding="3" cellspacing="0" border="0">'.implode("<br />", $output).'</table>';
	$output = str_replace("<br />", "", $output);

	return $output;
}*/

function getmicrotime()
{
    list($usec, $sec) = explode(" ",microtime()); 
    return ((float)$usec + (float)$sec); 
} 

?>